" nvim-lspconfig
lua << EOF
-- This section must be before setting up any LSP server for the automatic
-- installation of servers to work as expected.
require("mason").setup()  -- Just for updating paths to mason packages on launch
require("mason-lspconfig").setup({ automatic_installation = true })

local lspconfig = require("lspconfig")
local capabilities = vim.lsp.protocol.make_client_capabilities()
local lsp_capabilities = require("cmp_nvim_lsp").default_capabilities(capabilities)
local opts = require("lsp_server_settings")

lspconfig.pylsp.setup(
  vim.tbl_deep_extend("error", { capabilities = lsp_capabilities }, opts.pylsp)
)
lspconfig.clangd.setup { capabilities = lsp_capabilities }
EOF

lua << EOF
require("lsp.keymaps")
require("lsp.completion")
require("lsp.diagnostics")
EOF
