vim.diagnostic.config({
  signs = {
    text = {
      [vim.diagnostic.severity.ERROR] = "",
      [vim.diagnostic.severity.WARN] = "",
      [vim.diagnostic.severity.INFO] = "",
      [vim.diagnostic.severity.HINT] = "",
    }
  }
})

vim.api.nvim_create_autocmd("LspAttach", {
  group = vim.api.nvim_create_augroup("UserLspConfig", { clear = false }),
  callback = function(args)
    local bufnr = args.buf
    local client = vim.lsp.get_client_by_id(args.data.client_id)
    vim.api.nvim_create_autocmd("CursorHoldI", {
      group = vim.api.nvim_create_augroup("Diagnostics", { clear = true }),
      buffer = bufnr,
      callback = function()
        vim.diagnostic.open_float({ focusable = false, header = "" })
      end
    })

    vim.lsp.handlers["textDocument/publishDiagnostics"] = vim.lsp.with(
      vim.lsp.diagnostic.on_publish_diagnostics, {
        update_in_insert = true,
        virtual_text = { source = "if_many", spacing = 24 },
      }
    )
    vim.diagnostic.config({
      float = { source = "if_many", border = "rounded" }
    })
  end,
})
